// Per-pixel lighting shader for PBA Challenge
// Copyright 2016 Concrete Software. All rights reserved.

uniform mat4 cs_ModelViewProjectionMatrix;
// Model view matrix without projection multiplied in. Needed for specular lighting.
uniform mat4 cs_ModelViewMatrix;

uniform mat3 cs_NormalMatrix;

attribute vec4 cs_Vertex;
attribute vec3 cs_Normal;
attribute vec2 cs_MultiTexCoord0;

varying mediump vec2 var_TexCoord;
varying mediump vec3 var_Normal;
varying mediump vec3 var_TransformedVertex;
varying mediump vec2 var_ScreenCoord;

void main()
{
	var_Normal = cs_NormalMatrix * cs_Normal;
	var_TexCoord = cs_MultiTexCoord0.xy;
    var_TransformedVertex = (cs_ModelViewMatrix * cs_Vertex).xyz;
    vec4 screenCoord = cs_ModelViewProjectionMatrix * cs_Vertex;
    gl_Position = screenCoord;
	// It's not particularly important what this value is, so long as it is dependent on the location
    // where the thing is on the screen. This will let us map the noise texture flat over the pin,
    // which is what a 1950s-era special effect would have done.
    var_ScreenCoord = vec2(screenCoord.x, screenCoord.y) / screenCoord.w;
}