// tropical_water.fs
// Copyright 2016 Concrete Software, Inc.
//
// This shader is used for faking caustic "reflections" off the surface of the water in blackbeards cove.

uniform sampler2D texture;
uniform sampler2D pba_NextTexture;
uniform mediump float pba_TextureCombineAmount;
varying mediump vec2 var_TexCoord;

const lowp vec4 brightColor = vec4(0.3686274, 0.8666666, 0.8549018, 1.0);
const lowp vec4 darkColor = vec4(0.18431373, 0.43333334, 0.42745098, 1.0);

void main()
{
    gl_FragColor = mix(darkColor, brightColor, mix(texture2D(texture, var_TexCoord).r, texture2D(pba_NextTexture, var_TexCoord).r, pba_TextureCombineAmount));
}