// Water vertex shader for PBA Challenge
// Copyright 2015 Concrete Software. All rights reserved.

uniform mat4 cs_ModelViewProjectionMatrix;
// Model view matrix without projection multiplied in. Needed for specular lighting.
uniform mat4 cs_ModelViewMatrix;

attribute vec4 cs_Vertex;
attribute vec3 cs_Normal;
attribute vec2 cs_MultiTexCoord0;

uniform float pba_BumpScrollTime;

const float scrollAdjust = 2.;

const vec2 pba_BumpScrollRate1 = vec2(-0.0008, -.008) * scrollAdjust;
const vec2 pba_BumpScrollRate2 = vec2(0.0015, -0.003) * scrollAdjust;
const vec2 pba_BumpScrollRate3 = vec2(-.003, -.009) * scrollAdjust;

varying mediump vec2 var_TexCoord;
varying highp vec2 var_BumpTexCoord1;
varying highp vec2 var_BumpTexCoord2;
varying highp vec2 var_BumpTexCoord3;
varying mediump vec3 var_Normal;
varying mediump vec3 var_TransformedVertex;

void main()
{
	var_Normal = cs_Normal;

    var_TexCoord = cs_MultiTexCoord0.xy;
	var_BumpTexCoord1 = cs_MultiTexCoord0.xy*2.5+pba_BumpScrollTime*pba_BumpScrollRate1;
	var_BumpTexCoord2 = cs_MultiTexCoord0.xy*1.5+pba_BumpScrollTime*pba_BumpScrollRate2;
	var_BumpTexCoord3 = cs_MultiTexCoord0.xy*0.5+pba_BumpScrollTime*pba_BumpScrollRate3;
	var_TransformedVertex = (cs_ModelViewMatrix * cs_Vertex).xyz;
	gl_Position = cs_ModelViewProjectionMatrix * cs_Vertex;
}