// water_reflection.fs
// Copyright 2015 Concrete Software, Inc.
//
// This shader is used for faking caustic "reflections" off the surface of the water in blackbeards cove.

uniform sampler2D texture;
uniform sampler2D pba_NextTexture;
uniform mediump float pba_TextureCombineAmount;
varying mediump vec2 var_TexCoord;
varying mediump float var_Alpha;

const mediump vec4 reflectionColor = vec4(0.18431373, 0.43333334, 0.42745098, 0.5);

void main()
{
    gl_FragColor = mix(texture2D(texture, var_TexCoord), texture2D(pba_NextTexture, var_TexCoord), pba_TextureCombineAmount) * reflectionColor * var_Alpha;
}