// water_reflection.vs
// Copyright 2015 Concrete Software, Inc.
//
// This shader is used for faking caustic "reflections" off the surface of the water in blackbeards cove.


uniform mat4 cs_ModelViewProjectionMatrix;

attribute vec4 cs_Vertex;
attribute vec2 cs_MultiTexCoord0;

varying mediump vec2 var_TexCoord;
varying mediump float var_Alpha;

const mediump float maxReflectionHeight = 0.5;

void main()
{
    gl_Position = cs_ModelViewProjectionMatrix * cs_Vertex;
    var_Alpha = clamp(1.-cs_Vertex.y/maxReflectionHeight, 0., 1.); // this works because the model has an identity transformation
    var_TexCoord = cs_MultiTexCoord0 * 9.;
}